# Author: Shyam Patel
import pandas as pd

#replace these with the start and end directories number components 
startDir = 1
endDir = 1

baseName = "" # (i.e /lustre/...)
dataFrames = []
resid = {}
firstRun = True

# start and end for each inter_NUM.dat file in directory
startFile = 1
endFile = 15
fileBase = "inter_"

dir =  baseName + str(startDir)
counter = 0
for currDir in range(startDir, endDir+1):
    dir = baseName + str(currDir) + "/";
    for currFile in range(startFile, endFile+1):
        file = dir  + fileBase + str(currFile) + ".dat" 
        currFrame = pd.read_csv(file, sep="\s+")
        dataFrames.append(currFrame)
        key = currFrame._get_value(1, "RESID")

        if key in resid.keys():
            resid[key] = pd.concat([resid.get(key), currFrame])
        else :
            resid[key] = currFrame
totalFrame = pd.concat(dataFrames)
totalFrame.to_csv("result.dat", index=False, sep=" ")
cols = ["RESID", "TIME", "TOTAL", "VDW", "ELEC"]
for col in cols:
    name = col + ".dat"
    name = name.lower()
    totalFrame.to_csv(name, index=False, sep = " ", columns=[col])
    file = open(name, 'a')
    file.write("Mean: " + str(totalFrame[col].mean()) + "\n")
    file.write("SEM: " + str(totalFrame[col].sem()) + "\n")
    file.close()

residFile = open("perRes.dat", 'w')
residFile.write("RESID TOTAL_MEAN TOTAL_SEM VDW_MEAN VDW_SEM ELEC_MEAN ELEC_SEM  \n")
for num in range(startFile, endFile+1):
    resid_cols = ["TOTAL", "VDW", "ELEC"]
    residFile.write(str(num))
    for resid_col in resid_cols:
        avg = resid.get(num)[resid_col].mean()
        sem = resid.get(num)[resid_col].sem()
        toWrite = " " + str(avg) + " " + str(sem)
        residFile.write(toWrite)
    residFile.write("\n")
residFile.close()


